searchNodes=[{"ref":"SyncPrimitives.html","title":"SyncPrimitives","type":"module","doc":"SyncPrimitives offers a variety of synchronization primitives, such as SyncPrimitives.CyclicBarrier."},{"ref":"SyncPrimitives.CyclicBarrier.html","title":"SyncPrimitives.CyclicBarrier","type":"module","doc":"A CyclicBarrier expects a predefined number of parties to arrive at the barrier. Parties arrive at the barrier by calling await/1 or await/2. When all parties have arrived, all calls to await/1 or await/2 unblock, and parties may proceed. Thereafter, the barrier resets (which is what makes it cyclic). Although this fully describes the happy path, documentation for time outs, participating parties that exit, and other sad paths is currently lacking. Example iex&gt; barrier = SyncPrimitives.CyclicBarrier.start(2, fn -&gt; IO.puts(&quot;barrier action&quot;) end) {SyncPrimitives.CyclicBarrier, #PID&lt;0.149.0&gt;} iex&gt; spawn_link(fn -&gt; ...&gt; IO.puts(&quot;process 1, before wait&quot;) ...&gt; SyncPrimitives.CyclicBarrier.await(barrier) ...&gt; IO.puts(&quot;process 1, after wait&quot;) ...&gt; end) process 1, before wait #PID&lt;0.155.0&gt; iex&gt; spawn_link(fn -&gt; ...&gt; IO.puts(&quot;process 2, before wait&quot;) ...&gt; SyncPrimitives.CyclicBarrier.await(barrier) ...&gt; IO.puts(&quot;process 2, after wait&quot;) ...&gt; end) process 2, before wait #PID&lt;0.161.0&gt; barrier action process 1, after wait process 2, after wait"},{"ref":"SyncPrimitives.CyclicBarrier.html#alive?/1","title":"SyncPrimitives.CyclicBarrier.alive?/1","type":"function","doc":""},{"ref":"SyncPrimitives.CyclicBarrier.html#await/2","title":"SyncPrimitives.CyclicBarrier.await/2","type":"function","doc":""},{"ref":"SyncPrimitives.CyclicBarrier.html#broken?/1","title":"SyncPrimitives.CyclicBarrier.broken?/1","type":"function","doc":"Returns true, if any of the parties waiting for the barrier timed out or, exited since construction or the last reset, false otherwise."},{"ref":"SyncPrimitives.CyclicBarrier.html#number_waiting/1","title":"SyncPrimitives.CyclicBarrier.number_waiting/1","type":"function","doc":"Returns the number of parties currently waiting for the barrier."},{"ref":"SyncPrimitives.CyclicBarrier.html#parties/1","title":"SyncPrimitives.CyclicBarrier.parties/1","type":"function","doc":"Returns the number of parties required to trip this barrier."},{"ref":"SyncPrimitives.CyclicBarrier.html#reset/1","title":"SyncPrimitives.CyclicBarrier.reset/1","type":"function","doc":"Resets the barrier to its initial state. If any parties are currently waiting at the barrier, the await/1 or await/2 calls will return :broken."},{"ref":"SyncPrimitives.CyclicBarrier.html#start/2","title":"SyncPrimitives.CyclicBarrier.start/2","type":"function","doc":"Starts a new CyclicBarrier that expects parties processes to call await/1 or await/2 before it releases. Calls to await/1 block until all expected parties have called await/1. Thereafter, the barrier resets (which is what makes it cyclic)."},{"ref":"SyncPrimitives.CyclicBarrier.html#stop/1","title":"SyncPrimitives.CyclicBarrier.stop/1","type":"function","doc":""},{"ref":"SyncPrimitives.CyclicBarrier.html#t:barrier/0","title":"SyncPrimitives.CyclicBarrier.barrier/0","type":"type","doc":""}]